diff -r 6aa93995a880 -r 4d2ac6364509 apps/app_voicemail.c
--- a/apps/app_voicemail.c	Wed Jun 04 16:54:32 2014 +0100
+++ b/apps/app_voicemail.c	Fri Jun 27 17:25:53 2014 +0100
@@ -3286,7 +3286,13 @@
 		struct vm_state *vms;
 		pthread_once(&ts_vmstate.once, ts_vmstate.key_init);
 		vms = pthread_getspecific(ts_vmstate.key);
-		return vms;
+
+		if (vms != NULL) {
+			if (strcmp(vms->imapuser, user) == 0)
+				return vms;
+
+			ast_log(AST_LOG_NOTICE, "stored interactive state is for %s but requested %s\n", vms->imapuser, user);
+		}
 	}
 
 	AST_LIST_LOCK(&vmstates);
@@ -3325,7 +3331,14 @@
 		struct vm_state *vms;
 		pthread_once(&ts_vmstate.once, ts_vmstate.key_init);
 		vms = pthread_getspecific(ts_vmstate.key);
-		return vms;
+
+		if (vms != NULL) {
+			if (strcmp(vms->username, mailbox) == 0 && strcmp(vms->context, context) == 0)
+				return vms;
+
+			ast_log(AST_LOG_NOTICE, "stored interactive state is for %s/%s but wanted %s/%s\n",
+				vms->context, vms->username, context, mailbox);
+		}
 	}
 
 	AST_LIST_LOCK(&vmstates);
